package com.hai.blx.service;

import com.hai.entity.BlxCarInfo;
import com.hai.entity.GoodsPresent;

import java.util.List;
import java.util.Map;

/**
 * @serviceName .java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // 比邻星车辆业务
 * @createTime 11:28 2023/9/5
 **/
public interface BlxCarService {

    /**
    * @Author Sum1Dream
    * @Name insertCar
    * @Description // 新增车辆信息
    * @Date 11:29 2023/9/5
    * @Param carInfo
     * @return void
    */
    void insertCar(BlxCarInfo carInfo);

    /**
    * @Author Sum1Dream
    * @Name updateCar
    * @Description // 更新车辆信息
    * @Date 11:29 2023/9/5
    * @Param carInfo
     * @return void
    */
    void updateCar(BlxCarInfo carInfo);

    /**
    * @Author Sum1Dream
    * @Name getCarInfoList
    * @Description // 查询车辆信息列表
    * @Date 11:30 2023/9/5
    * @Param map
     * @return java.util.List<com.hai.entity.BlxCarInfo>
    */
    List<BlxCarInfo> getCarInfoList(Map<String , Object> map);

    /**
    * @Author Sum1Dream
    * @Name findCarInfoByMap
    * @Description //TODO
    * @Date 14:14 2023/9/5
    * @Param map
     * @return com.hai.entity.BlxCarInfo
    */
    BlxCarInfo findCarInfoByMap(Map<String , Object> map);

    /**
    * @Author Sum1Dream
    * @Name findCarInfoById
    * @Description // 根据ID查询详情
    * @Date 15:13 2023/9/5
    * @Param id
     * @return com.hai.entity.BlxCarInfo
    */
    BlxCarInfo findCarInfoById(Long id);
}
