package com.hai.dao;

import com.hai.entity.BlxCarInfo;
import com.hai.entity.BlxCarInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BlxCarInfoMapper extends BlxCarInfoMapperExt {
    @SelectProvider(type=BlxCarInfoSqlProvider.class, method="countByExample")
    long countByExample(BlxCarInfoExample example);

    @DeleteProvider(type=BlxCarInfoSqlProvider.class, method="deleteByExample")
    int deleteByExample(BlxCarInfoExample example);

    @Delete({
        "delete from blx_car_info",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into blx_car_info (user_id, car_no, ",
        "car_no_type, default_car_no, ",
        "create_time, update_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{userId,jdbcType=BIGINT}, #{carNo,jdbcType=VARCHAR}, ",
        "#{carNoType,jdbcType=INTEGER}, #{defaultCarNo,jdbcType=BIT}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BlxCarInfo record);

    @InsertProvider(type=BlxCarInfoSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BlxCarInfo record);

    @SelectProvider(type=BlxCarInfoSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="car_no", property="carNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="car_no_type", property="carNoType", jdbcType=JdbcType.INTEGER),
        @Result(column="default_car_no", property="defaultCarNo", jdbcType=JdbcType.BIT),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BlxCarInfo> selectByExample(BlxCarInfoExample example);

    @Select({
        "select",
        "id, user_id, car_no, car_no_type, default_car_no, create_time, update_time, ",
        "`status`, ext_1, ext_2, ext_3",
        "from blx_car_info",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="car_no", property="carNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="car_no_type", property="carNoType", jdbcType=JdbcType.INTEGER),
        @Result(column="default_car_no", property="defaultCarNo", jdbcType=JdbcType.BIT),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BlxCarInfo selectByPrimaryKey(Long id);

    @UpdateProvider(type=BlxCarInfoSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BlxCarInfo record, @Param("example") BlxCarInfoExample example);

    @UpdateProvider(type=BlxCarInfoSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BlxCarInfo record, @Param("example") BlxCarInfoExample example);

    @UpdateProvider(type=BlxCarInfoSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BlxCarInfo record);

    @Update({
        "update blx_car_info",
        "set user_id = #{userId,jdbcType=BIGINT},",
          "car_no = #{carNo,jdbcType=VARCHAR},",
          "car_no_type = #{carNoType,jdbcType=INTEGER},",
          "default_car_no = #{defaultCarNo,jdbcType=BIT},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BlxCarInfo record);
}