package com.hai.dao;

import com.hai.entity.BsPushScheduleTask;
import com.hai.entity.BsPushScheduldTaskExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsPushScheduldTaskMapper extends BsPushScheduldTaskMapperExt {
    @SelectProvider(type=BsPushScheduldTaskSqlProvider.class, method="countByExample")
    long countByExample(BsPushScheduldTaskExample example);

    @DeleteProvider(type=BsPushScheduldTaskSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsPushScheduldTaskExample example);

    @Delete({
        "delete from bs_push_scheduld_task",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_push_scheduld_task (source_type, source_id, ",
        "request_id, push_time, ",
        "create_time, update_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3, ext_4, ext_5, ",
        "ext_6)",
        "values (#{sourceType,jdbcType=INTEGER}, #{sourceId,jdbcType=BIGINT}, ",
        "#{requestId,jdbcType=VARCHAR}, #{pushTime,jdbcType=TIMESTAMP}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR}, #{ext4,jdbcType=VARCHAR}, #{ext5,jdbcType=VARCHAR}, ",
        "#{ext6,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsPushScheduleTask record);

    @InsertProvider(type=BsPushScheduldTaskSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsPushScheduleTask record);

    @SelectProvider(type=BsPushScheduldTaskSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="request_id", property="requestId", jdbcType=JdbcType.VARCHAR),
        @Result(column="push_time", property="pushTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_4", property="ext4", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_5", property="ext5", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_6", property="ext6", jdbcType=JdbcType.VARCHAR)
    })
    List<BsPushScheduleTask> selectByExample(BsPushScheduldTaskExample example);

    @Select({
        "select",
        "id, source_type, source_id, request_id, push_time, create_time, update_time, ",
        "`status`, ext_1, ext_2, ext_3, ext_4, ext_5, ext_6",
        "from bs_push_scheduld_task",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="request_id", property="requestId", jdbcType=JdbcType.VARCHAR),
        @Result(column="push_time", property="pushTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_4", property="ext4", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_5", property="ext5", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_6", property="ext6", jdbcType=JdbcType.VARCHAR)
    })
    BsPushScheduleTask selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsPushScheduldTaskSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsPushScheduleTask record, @Param("example") BsPushScheduldTaskExample example);

    @UpdateProvider(type=BsPushScheduldTaskSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsPushScheduleTask record, @Param("example") BsPushScheduldTaskExample example);

    @UpdateProvider(type=BsPushScheduldTaskSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsPushScheduleTask record);

    @Update({
        "update bs_push_scheduld_task",
        "set source_type = #{sourceType,jdbcType=INTEGER},",
          "source_id = #{sourceId,jdbcType=BIGINT},",
          "request_id = #{requestId,jdbcType=VARCHAR},",
          "push_time = #{pushTime,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR},",
          "ext_4 = #{ext4,jdbcType=VARCHAR},",
          "ext_5 = #{ext5,jdbcType=VARCHAR},",
          "ext_6 = #{ext6,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsPushScheduleTask record);
}
