package com.hai.dao;

import com.hai.entity.GoodsDetail;
import com.hai.entity.GoodsDetailExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface GoodsDetailMapper extends GoodsDetailMapperExt {
    @SelectProvider(type=GoodsDetailSqlProvider.class, method="countByExample")
    long countByExample(GoodsDetailExample example);

    @DeleteProvider(type=GoodsDetailSqlProvider.class, method="deleteByExample")
    int deleteByExample(GoodsDetailExample example);

    @Delete({
        "delete from goods_detail",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into goods_detail (company_id, goods_type_name, ",
        "goods_type, goods_label, ",
        "`name`, list_describe, ",
        "goods_describe, list_img, ",
        "banner_img, detail_img, ",
        "`status`, create_time, ",
        "update_time, op_id, ",
        "op_name, ext_1, ext_2, ",
        "ext_3)",
        "values (#{companyId,jdbcType=BIGINT}, #{goodsTypeName,jdbcType=VARCHAR}, ",
        "#{goodsType,jdbcType=BIGINT}, #{goodsLabel,jdbcType=VARCHAR}, ",
        "#{name,jdbcType=VARCHAR}, #{listDescribe,jdbcType=VARCHAR}, ",
        "#{goodsDescribe,jdbcType=VARCHAR}, #{listImg,jdbcType=VARCHAR}, ",
        "#{bannerImg,jdbcType=VARCHAR}, #{detailImg,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{opId,jdbcType=BIGINT}, ",
        "#{opName,jdbcType=VARCHAR}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(GoodsDetail record);

    @InsertProvider(type=GoodsDetailSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(GoodsDetail record);

    @SelectProvider(type=GoodsDetailSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_type_name", property="goodsTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_type", property="goodsType", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_label", property="goodsLabel", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="list_describe", property="listDescribe", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_describe", property="goodsDescribe", jdbcType=JdbcType.VARCHAR),
        @Result(column="list_img", property="listImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="banner_img", property="bannerImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="detail_img", property="detailImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<GoodsDetail> selectByExample(GoodsDetailExample example);

    @Select({
        "select",
        "id, company_id, goods_type_name, goods_type, goods_label, `name`, list_describe, ",
        "goods_describe, list_img, banner_img, detail_img, `status`, create_time, update_time, ",
        "op_id, op_name, ext_1, ext_2, ext_3",
        "from goods_detail",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_type_name", property="goodsTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_type", property="goodsType", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_label", property="goodsLabel", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="list_describe", property="listDescribe", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_describe", property="goodsDescribe", jdbcType=JdbcType.VARCHAR),
        @Result(column="list_img", property="listImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="banner_img", property="bannerImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="detail_img", property="detailImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    GoodsDetail selectByPrimaryKey(Long id);

    @UpdateProvider(type=GoodsDetailSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") GoodsDetail record, @Param("example") GoodsDetailExample example);

    @UpdateProvider(type=GoodsDetailSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") GoodsDetail record, @Param("example") GoodsDetailExample example);

    @UpdateProvider(type=GoodsDetailSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(GoodsDetail record);

    @Update({
        "update goods_detail",
        "set company_id = #{companyId,jdbcType=BIGINT},",
          "goods_type_name = #{goodsTypeName,jdbcType=VARCHAR},",
          "goods_type = #{goodsType,jdbcType=BIGINT},",
          "goods_label = #{goodsLabel,jdbcType=VARCHAR},",
          "`name` = #{name,jdbcType=VARCHAR},",
          "list_describe = #{listDescribe,jdbcType=VARCHAR},",
          "goods_describe = #{goodsDescribe,jdbcType=VARCHAR},",
          "list_img = #{listImg,jdbcType=VARCHAR},",
          "banner_img = #{bannerImg,jdbcType=VARCHAR},",
          "detail_img = #{detailImg,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(GoodsDetail record);
}