package com.hai.service;

import com.alibaba.fastjson.JSONObject;
import com.hai.entity.HighGoodsType;
import com.hai.entity.HighOrderPre;

import java.util.List;
import java.util.Map;

public interface HighGoodsTypeService {

    /**
     * @Author Sum1Dream
     * @Description // 查询
     * @Date 15:18 2021/6/11
     * @Param [map]
     * @return java.util.List<com.hai.entity.HighOrderPre>
     **/
    List<HighGoodsType> getListGoodsType(Map<String , String> map);

    /**
     * @Author Sum1Dream
     * @Description // 根据ID查询
     * @Date 15:19 2021/6/11
     * @Param [orderId]
     * @return com.hai.entity.HighOrderPre
     **/
    HighGoodsType findById(Integer Id);

    /**
    * @Author Sum1Dream
    * @name HighGoodsType.java
    * @Description // 根据标题判断是否存在
    * @Date 4:58 下午 2021/11/11
    * @Param
    * @return
    **/
    Boolean findByTitle(String title);


    /***
     * @Author Sum1Dream
     * @Description // 新增
     * @Date 15:25 2021/6/11
     * @Param [HighOrderPre]
     * @return void
     **/
    void insertGoodsType(HighGoodsType highGoodsType);

    /***
     * @Author Sum1Dream
     * @Description // 修改
     * @Date 15:26 2021/6/11
     * @Param [HighOrderPre]
     * @return void
     **/
    void updateGoodsType(HighGoodsType highGoodsType);

    /**
     * @Author Sum1Dream
     * @Name getGoodsTypeTree
     * @Description // 获取商品类型树结构
     * @Date 14:23 2023/4/12
     * @Param [businessType]
     * @Return com.alibaba.fastjson.JSONObject
     */
    List<JSONObject>  getGoodsTypeTree(Integer businessType);
}
